void draw()
    {
       background(192);
      
       textAlign(CENTER,CENTER);        ///alignment of text wrt position
       textFont(font);        //decide the font
       //fill(255);              // decide color
      //loop to display orginal matrix
      
      
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  float intensity = map ( myArray [i][j], 0,maxCount,0,255);
                  fill(intensity);
                  rect(Xmargin+ j* rectWidth ,YMargin+ i* rectHeight,  rectWidth, rectHeight);
                  
                  if (numbersFlag)
                      {
                      fill(numberColor);
                      text( int ( myArray [i][j] ) , Xmargin+ j* rectWidth + rectWidth/2,YMargin+ i* rectHeight + rectHeight/2 ); 
                      }
                }
          }
       
       
       for ( int  i = 0 ; i< rows ; i++ )
           {
            fill(labelColor);
            text( days[i] ,  Xmargin/2 ,YMargin+ i* rectHeight + rectHeight/2 );
           }
       
       for ( int j = 0; j< cols ; j++ )
           {
            fill(labelColor);
            text( years[j] ,  Xmargin+ j * rectWidth + rectWidth/2  ,YMargin /2 );
           }
           
           
       if( sumRowFlag)
         {
         // loop to display weighted sums   
         for ( int  i = 0 ; i< rows ; i++ )
            {
            float intensity = map ( sumOfRows[i], 0, maxCount* 4,0,255);
            fill(intensity);
            rect(originalSumPosition, rectHeight* i + YMargin ,  rectWidth, rectHeight);
            if (numbersFlag)
               {
                fill(numberColor);
                text( int ( sumOfRows[i] ) , originalSumPosition + rectWidth/2, rectHeight/2 + rectHeight* i + YMargin ); 
               }
             }
         }
         
        if(COFlag)
          {
             // loop to display reordered sum of rows and tracked rows
             for ( int  i = 0 ; i< rows ; i++ )
                  {
                  fill(labelColor);            
                  text(   orderedDays[i]  , 450 + rectWidth/4, rectHeight/2 + rectHeight* i + YMargin );         
                  } 
                  
             for ( int j = 0; j< cols ; j++ )
                 {
                  fill(labelColor);
                  text( years[j] ,  rowOrderinIndex + Xmargin + j * rectWidth + rectWidth/2  ,YMargin /2 );
                 }
                 
             // loop to display the reordered matrix ( according to rows)
             // we still need to reordered columns
              for ( int  i = 0 ; i< rows ; i++ )
                  {
                    for ( int j = 0; j< cols ; j++ )
                        {
                          
                          float intensity = map ( rowWeightedArray[i][j], 0,maxCount,0,255);
                          fill(intensity);
                          rect(rowOrderinIndex + Xmargin+ j* rectWidth ,YMargin+ i* rectHeight,  rectWidth, rectHeight);
                             if (numbersFlag)
                                {
                                fill(numberColor);
                                text( int ( rowWeightedArray [i][j] ) ,rowOrderinIndex + Xmargin+ j* rectWidth + rectWidth/2,YMargin+ i* rectHeight + rectHeight/2 );                                 
                                }
                        }
                  }
              
          } 
         if( ROFlag)
            {
                // loop to display rearraged sums and color coded rows 
               for ( int  i = 0 ; i< cols ; i++ )
                    {    
                      fill(labelColor);
                      text( orderedYears[i] , rowOrderedSumPosition + Xmargin + rectWidth * i + rectWidth/2,  YMargin/6 + YMargin/2  ); 
                    }
              
               for ( int  i = 0 ; i< rows ; i++ )
                   {
                    fill(labelColor);
                    text( orderedDays[i] , rowOrderedArrayPosition + Xmargin/2 ,YMargin+ i* rectHeight + rectHeight/2 );
                   }
               // tracker of column changes

                ///// final array column weighted
                
                for ( int  i = 0 ; i< rows ; i++ )
                  {
                    for ( int j = 0; j< cols ; j++ )
                        {                          
                          float intensity = map ( columnWeightedArray[i][j], 0,maxCount,0,255);
                          fill(intensity);
                          rect(rowOrderedArrayPosition+ Xmargin+ j* rectWidth ,YMargin+ i* rectHeight,  rectWidth, rectHeight);
                            if (numbersFlag)
                                {
                                fill(numberColor);
                                text( int ( columnWeightedArray [i][j] ) ,rowOrderedArrayPosition+ Xmargin+ j* rectWidth + rectWidth/2,YMargin+ i* rectHeight + rectHeight/2 );           
                                }
                        }
                  }
                
                
            }

    //end of draw      
          
          
    }
    
