                     
void setup()
    {
      
      size(1200,800);
      background(255);
      strokeWeight(0.5);
      
      myTable = loadTable( "SumByWeekDays.csv","header");
      
       for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {                 
                  myArray[i][j] =  myTable.getInt( j,i); 
                }
          }
      //////////////////////////////////////////////////////////////////////////////////      
       // ok now lets arrange the array by rows
    
      // initalizing weighted sums
      for ( int  i = 0 ; i< rows ; i++)
           sumOfRows[i] =0;
      
      // initalizing row numbers
      for ( int  i = 0 ; i< rows ; i++)
           trackerOfRowChanges[i] =i;     
           
      // weighting each rows
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {                 
                 sumOfRows[i] += myArray[i][j] * columnWeights[j]; 
                }
          }
        
          
      for ( int  i = 0 ; i< rows ; i++)    
          CopyOfSumOfRows[i] = sumOfRows[i];
      
      //reordering the matrix
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = i+1; j< rows ; j++ )
                { 
                 // bubble sort 
                 if ( CopyOfSumOfRows[i] > CopyOfSumOfRows[j] )
                     {
                       // switching numbers
                       float temp = CopyOfSumOfRows[i];
                       CopyOfSumOfRows[i] = CopyOfSumOfRows[j];
                       CopyOfSumOfRows[j] = temp;
                       
                       // tracking changes in rows
                       float tempRow = trackerOfRowChanges[i];
                       trackerOfRowChanges[i] = trackerOfRowChanges[j];
                       trackerOfRowChanges[j] = tempRow;
                       
                       String tempDay = orderedDays [i];
                       orderedDays[i] = orderedDays [j];
                       orderedDays[j] = tempDay;
                       
                     }
                      
                 
                }
          }
       // creating new row weighted array
       
       for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                  float pointerToCorrectRow =  trackerOfRowChanges[i];
                  rowWeightedArray[i][j] = myArray[int(pointerToCorrectRow)][j];
                                                   
                }
          }
          
    //////////////////////////////////////////////////////////////////////////////////      
       // ok now lets arrange the array by columns
       
    // initalizing weighted sums
      for ( int  i = 0 ; i< cols ; i++)
           sumOfColumns[i] =0;
      
      // initalizing column numbers
      for ( int  i = 0 ; i< cols ; i++)
           trackerOfColumnChanges[i] =i;     
           
      // weighting each column
      for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {                 
                 sumOfColumns[j] += myArray[i][j] * rowWeights[i]; 
                }
          }
          
          
       // copying to a new column   
       for ( int  i = 0 ; i< cols ; i++)    
          CopyOfSumOfColumns[i] = sumOfColumns[i];
      
      //reordering the matrix
      for ( int  i = 0 ; i< cols ; i++ )
          {
            for ( int j = i+1; j< cols ; j++ )
                { 
                 // bubble sort 
                 if ( CopyOfSumOfColumns[i] > CopyOfSumOfColumns[j] )
                     {
                       // switching numbers
                       float temp = CopyOfSumOfColumns[i];
                       CopyOfSumOfColumns[i] = CopyOfSumOfColumns[j];
                       CopyOfSumOfColumns[j] = temp;
                       
                       // tracking changes in cols
                       float tempColumns = trackerOfColumnChanges[i];
                       trackerOfColumnChanges[i] = trackerOfColumnChanges[j];
                       trackerOfColumnChanges[j] = tempColumns;
                       
                       String tempYears = orderedYears [i];
                       orderedYears[i] = orderedYears [j];
                       orderedYears[j] = tempYears;
                     }        
                }
          }   
          
     // creating new column weighted array
       
       for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                  int pointerToCorrectColumn =  int ( trackerOfColumnChanges[j] ) ;
                  columnWeightedArray[i][j] = rowWeightedArray[i][pointerToCorrectColumn];
                                                   
                }
          }
        
          
            
        for ( int  i = 0 ; i< rows ; i++ )
          {
            for ( int j = 0; j< cols ; j++ )
                {
                  
                 if( maxCount < myArray[i][j])
                    maxCount = myArray[i][j];
         
                }
          }
              
    //end of setup 
    println("maxcount: "+ maxCount);
    
    }
 
